package liste;
 
/**
 * Classe base per le etichette dei nodi di una lista.
 * 
 * In questa classe base si assume che l'etichetta sia un intero
 * 
 * @author Stefano Guerrini
 * @version Marzo 2009
 */
public class EtichettaNodo
{
    // valore dell'etichetta
    private int x;

    /**
     * Costruttore di oggetti della classe EtichettaNodo
     * 
     * Inizializza l'etichetta a 0
     */
    public EtichettaNodo()
    {
        x = 0;
    }

    /**
     * Costruttore di oggetti della classe EtichettaNodo
     * a partire da un valore intero
     * 
     * @param x     valore intero dell'etichetta del nuovo nodo
     */
    public EtichettaNodo(int x)
    {
        this.x = x;
    }

    //
    // getter
    //
    /**
     * Metodo getter: legge il valore intero dell'etichetta
     * 
     * @return      il intero valore dell'etcihetta
     */
    public int getIntVal()
    {
        return x;
    }

    //
    // setter
    //
    /**
     * Metodo setter: cambia il valore intero dell'etichetta
     * 
     * @param x     il nuovo valore intero dell'etcihetta
     */
    public void setIntVal(int x)
    {
        this.x = x;
    }

    /**
     * clona l'etichetta (crea un nuovo oggetto etichetta con lo stesso valore)
     * 
     * @return      la nuova etichetta
     */
    public EtichettaNodo clona()
    {
        return new EtichettaNodo(x);
    }

    /**
     * converte il valore dell'etichetta in una stringa
     * 
     * @return      la stringa
     */
    public String toString()
    {
        return x + "";
    }
}
