package liste;

/**
 * Classe con alcune funzioni su liste - versione iterativa
 * 
 * @author Stefano Guerrini
 * @version Marzo 2009
 */
public final class ListeLibIter
{
    /**
     * rovescia una lista (iterativa)
     * crea una nuova lista, clona anche le etichette
     * 
     * @param lista     lista da rovesciare
     * @return          la nuova lista
     */
    public static Nodo revLista(Nodo lista)
    {
        Nodo nuova = null;
        
        while (lista != null)
        {
            // duplico il nodo (anche l'oggetto dell'etichetta)
            nuova = new Nodo(lista.label().clona(), nuova);
            lista = lista.next();
        }
        
        return nuova;
    }

    /**
     * copia una lista (iterativa)
     * crea una nuova lista, clona anche le etichette
     * 
     * @param lista     lista da copiare
     * @return          la nuova lista
     */
    public static Nodo copiaLista(Nodo lista)
    {
        if (lista == null)
            return null;
            
        Nodo nuova = new Nodo(lista.label().clona());
        Nodo last = nuova;
        lista = lista.next();
        
        while (lista != null)
        {
            // aggiunge il nodo elemento in codoa 
            // (clona anche l'oggetto dell'etichetta)
            last.setNext(new Nodo(lista.label().clona()));
            last = last.next();
            lista = lista.next();
        }
        
        return nuova;
    }

    /**
     * stampa una lista (iterativa)
     * 
     * @param lista     lista da stampare
     */
    public static void stampaLista(Nodo lista)
    {
        for ( ; lista != null ; lista = lista.next() )
            System.out.print(lista.label().toString() + " ");
    }
}
