package liste.itera;

import liste.Nodo;

/**
 * Iteratore per le liste definite tramite la classe Nodo
 * 
 * @author Stefano Guerrini
 * @version Marzo 2009
 */
public class IteraSuLista
{
    private Nodo current;

    /**
     * Construttore di oggetti della classe IteraSuNodo
     * 
     * Inizializza l'iteratore
     */
    public IteraSuLista(Nodo nd)
    {
        // initialise instance variables
        current = nd;
    }

    /**
     * Verifica se ci sono ancora nodi da analizzare
     * 
     * @return     true se ci sono ancora nodi da analizzare, false altrimenti
     */
    public boolean hasNext()
    {
        return (current != null);
    }

    /**
     * Prende il prossimo nodo e avanza l'iteratore 
     * 
     * @return     il prossimo nodo
     */
    public Nodo next()
    {
        Nodo nd = current;
        current = current.next();
        return nd;
    }
}
